---
import ArrowSvg from "@/shared/svgs/ArrowSvg.astro";

interface Props {
  page: number;
  maxPage: number;
}

const { maxPage, page } = Astro.props;

const queryParams = new URLSearchParams(Astro.url.searchParams);
const limit = queryParams.get("limit") ?? "10";
---

<div class="bg-neutral-600 flex justify-end rounded py-4 px-6 w-2/4">
  <div class="flex items-center justify-center mr-4">
    <span class="text-sm mr-2">Items per page:</span>
    <select
      id="paginator-selecter"
      class={`
        bg-neutral-50 text-neutral-950 rounded py-1 px-2 ml-2 cursor-pointer
        outline outline-1 outline-neutral-100 focus:outline-2
      `}
      onchange="handleSelect(this)"
    >
      <option class="bg-neutral-700 text-neutral-100" value="10" selected={limit === "10"}>
        10
      </option>
      <option class="bg-neutral-700 text-neutral-100" value="15" selected={limit === "15"}>
        15
      </option>
      <option class="bg-neutral-700 text-neutral-100" value="20" selected={limit === "20"}>
        20
      </option>
      <option class="bg-neutral-700 text-neutral-100" value="25" selected={limit === "25"}>
        25
      </option>
    </select>
  </div>
  <div class="flex items-center justify-center">
    <p class="mx-2">Page: {page} - <b>{maxPage}</b></p>
    <button
      type="button"
      disabled={page <= 1}
      class="hover:opacity-50 disabled:opacity-20 rotate-[90deg] mr-1"
      onclick="previusPage()"
    >
      <ArrowSvg />
    </button>
    <button
      type="button"
      disabled={page >= maxPage}
      class="hover:opacity-50 disabled:opacity-20 rotate-[-90deg] ml-1"
      onclick="nextPage()"
    >
      <ArrowSvg />
    </button>
  </div>
</div>

<script is:inline>
  function handleSelect(input) {
    const queryParams = new URLSearchParams(window.location.search);
    queryParams.set("limit", input.value);
    queryParams.delete("offset");
    window.location.search = queryParams;
  }

  function previusPage() {
    const queryParams = new URLSearchParams(window.location.search);
    const offset = Number(queryParams.get("offset") ?? "0");
    const limit = Number(queryParams.get("limit") ?? "10");
    queryParams.set("offset", offset - limit);
    window.location.search = queryParams;
  }

  function nextPage() {
    const queryParams = new URLSearchParams(window.location.search);
    const offset = Number(queryParams.get("offset") ?? "0");
    const limit = Number(queryParams.get("limit") ?? "10");
    queryParams.set("offset", offset + limit);
    window.location.search = queryParams;
  }
</script>
